/* PreferencesDialog.c generated by valac, the Vala compiler
 * generated from PreferencesDialog.vala, do not modify */

/*
 *  Copyright (C) 2009-2010 Michael J. Chudobiak.
 *
 *  This file is part of moserial.
 *
 *  moserial is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  moserial is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with moserial.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define MOSERIAL_TYPE_PREFERENCES_DIALOG (moserial_preferences_dialog_get_type ())
#define MOSERIAL_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MOSERIAL_TYPE_PREFERENCES_DIALOG, moserialPreferencesDialog))
#define MOSERIAL_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MOSERIAL_TYPE_PREFERENCES_DIALOG, moserialPreferencesDialogClass))
#define MOSERIAL_IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MOSERIAL_TYPE_PREFERENCES_DIALOG))
#define MOSERIAL_IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MOSERIAL_TYPE_PREFERENCES_DIALOG))
#define MOSERIAL_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MOSERIAL_TYPE_PREFERENCES_DIALOG, moserialPreferencesDialogClass))

typedef struct _moserialPreferencesDialog moserialPreferencesDialog;
typedef struct _moserialPreferencesDialogClass moserialPreferencesDialogClass;
typedef struct _moserialPreferencesDialogPrivate moserialPreferencesDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;

struct _moserialPreferencesDialog {
	GObject parent_instance;
	moserialPreferencesDialogPrivate * priv;
};

struct _moserialPreferencesDialogClass {
	GObjectClass parent_class;
};

struct _moserialPreferencesDialogPrivate {
	GtkBuilder* _builder;
	GtkDialog* dialog;
	GtkButton* cancelButton;
	GtkButton* okButton;
	GtkCheckButton* systemFont;
	GtkFontButton* fontButton;
	GtkColorButton* fontColorButton;
	GtkColorButton* backgroundColorButton;
	GtkColorButton* highlightColorButton;
	GtkCheckButton* recordLaunch;
	GtkCheckButton* enableTimeout;
	GtkSpinButton* timeout;
};


static gpointer moserial_preferences_dialog_parent_class = NULL;

GType moserial_preferences_dialog_get_type (void);
#define MOSERIAL_PREFERENCES_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MOSERIAL_TYPE_PREFERENCES_DIALOG, moserialPreferencesDialogPrivate))
enum  {
	MOSERIAL_PREFERENCES_DIALOG_DUMMY_PROPERTY,
	MOSERIAL_PREFERENCES_DIALOG_BUILDER
};
static void moserial_preferences_dialog_set_builder (moserialPreferencesDialog* self, GtkBuilder* value);
moserialPreferencesDialog* moserial_preferences_dialog_new (GtkBuilder* builder);
moserialPreferencesDialog* moserial_preferences_dialog_construct (GType object_type, GtkBuilder* builder);
gboolean moserial_preferences_dialog_hide (moserialPreferencesDialog* self);
Preferences* preferences_new (gboolean useSystemMonospaceFont, const char* font, const char* fontColor, const char* backgroundColor, const char* highlightColor, gboolean recordLaunch, gboolean enableTimeout, gint timeout);
Preferences* preferences_construct (GType object_type, gboolean useSystemMonospaceFont, const char* font, const char* fontColor, const char* backgroundColor, const char* highlightColor, gboolean recordLaunch, gboolean enableTimeout, gint timeout);
GType preferences_get_type (void);
void moserial_preferences_dialog_ok (moserialPreferencesDialog* self, GtkButton* button);
gboolean preferences_get_useSystemMonospaceFont (Preferences* self);
const char* preferences_get_font (Preferences* self);
void preferences_getGdkColor (const char* color, GdkColor* result);
const char* preferences_get_fontColor (Preferences* self);
const char* preferences_get_backgroundColor (Preferences* self);
const char* preferences_get_highlightColor (Preferences* self);
gboolean preferences_get_recordLaunch (Preferences* self);
gboolean preferences_get_enableTimeout (Preferences* self);
gint preferences_get_timeout (Preferences* self);
void moserial_preferences_dialog_show (moserialPreferencesDialog* self, Preferences* preferences, gboolean recording);
void moserial_preferences_dialog_cancel (moserialPreferencesDialog* self, GtkWidget* w);
void moserial_preferences_dialog_systemFontToggled (moserialPreferencesDialog* self, GtkCheckButton* button);
void moserial_preferences_dialog_enableTimeoutToggled (moserialPreferencesDialog* self, GtkCheckButton* button);
GtkBuilder* moserial_preferences_dialog_get_builder (moserialPreferencesDialog* self);
static void _moserial_preferences_dialog_systemFontToggled_gtk_toggle_button_toggled (GtkCheckButton* _sender, gpointer self);
static void _moserial_preferences_dialog_enableTimeoutToggled_gtk_toggle_button_toggled (GtkCheckButton* _sender, gpointer self);
static void _moserial_preferences_dialog_ok_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _moserial_preferences_dialog_cancel_gtk_button_clicked (GtkButton* _sender, gpointer self);
static gboolean _moserial_preferences_dialog_hide_gtk_widget_delete_event (GtkDialog* _sender, GdkEvent* event, gpointer self);
static GObject * moserial_preferences_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void moserial_preferences_dialog_finalize (GObject* obj);
static void moserial_preferences_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void moserial_preferences_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



moserialPreferencesDialog* moserial_preferences_dialog_construct (GType object_type, GtkBuilder* builder) {
	GParameter * __params;
	GParameter * __params_it;
	moserialPreferencesDialog * self;
	g_return_val_if_fail (builder != NULL, NULL);
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
	__params_it->name = "builder";
	g_value_init (&__params_it->value, GTK_TYPE_BUILDER);
	g_value_set_object (&__params_it->value, builder);
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


moserialPreferencesDialog* moserial_preferences_dialog_new (GtkBuilder* builder) {
	return moserial_preferences_dialog_construct (MOSERIAL_TYPE_PREFERENCES_DIALOG, builder);
}


void moserial_preferences_dialog_ok (moserialPreferencesDialog* self, GtkButton* button) {
	gboolean pSystemFont = FALSE;
	char* pFont;
	char* pFontColor;
	char* pBackgroundColor;
	char* pHighlightColor;
	gboolean pRecordLaunch = FALSE;
	gboolean pEnableTimeout = FALSE;
	gint pTimeout = 0;
	char* _tmp0_;
	GdkColor c = {0};
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	Preferences* preferences;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	moserial_preferences_dialog_hide (self);
	pFont = NULL;
	pFontColor = NULL;
	pBackgroundColor = NULL;
	pHighlightColor = NULL;
	if (gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->systemFont)) {
		pSystemFont = TRUE;
	} else {
		pSystemFont = FALSE;
	}
	pFont = (_tmp0_ = g_strdup (gtk_font_button_get_font_name (self->priv->fontButton)), _g_free0 (pFont), _tmp0_);
	gtk_color_button_get_color (self->priv->fontColorButton, &c);
	pFontColor = (_tmp1_ = gdk_color_to_string (&c), _g_free0 (pFontColor), _tmp1_);
	gtk_color_button_get_color (self->priv->backgroundColorButton, &c);
	pBackgroundColor = (_tmp2_ = gdk_color_to_string (&c), _g_free0 (pBackgroundColor), _tmp2_);
	gtk_color_button_get_color (self->priv->highlightColorButton, &c);
	pHighlightColor = (_tmp3_ = gdk_color_to_string (&c), _g_free0 (pHighlightColor), _tmp3_);
	if (gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->recordLaunch)) {
		pRecordLaunch = TRUE;
	} else {
		pRecordLaunch = FALSE;
	}
	if (gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->enableTimeout)) {
		pEnableTimeout = TRUE;
	} else {
		pEnableTimeout = FALSE;
	}
	pTimeout = (gint) gtk_spin_button_get_value (self->priv->timeout);
	preferences = preferences_new (pSystemFont, pFont, pFontColor, pBackgroundColor, pHighlightColor, pRecordLaunch, pEnableTimeout, pTimeout);
	g_signal_emit_by_name (self, "update-preferences", preferences);
	_g_free0 (pFont);
	_g_free0 (pFontColor);
	_g_free0 (pBackgroundColor);
	_g_free0 (pHighlightColor);
	_g_object_unref0 (preferences);
}


void moserial_preferences_dialog_show (moserialPreferencesDialog* self, Preferences* preferences, gboolean recording) {
	GdkColor _tmp1_;
	GdkColor _tmp0_ = {0};
	GdkColor _tmp3_;
	GdkColor _tmp2_ = {0};
	GdkColor _tmp5_;
	GdkColor _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (preferences != NULL);
	if (preferences_get_useSystemMonospaceFont (preferences)) {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->fontButton, FALSE);
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->systemFont, TRUE);
	} else {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->fontButton, TRUE);
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->systemFont, FALSE);
	}
	gtk_font_button_set_font_name (self->priv->fontButton, preferences_get_font (preferences));
	gtk_color_button_set_color (self->priv->fontColorButton, (_tmp1_ = (preferences_getGdkColor (preferences_get_fontColor (preferences), &_tmp0_), _tmp0_), &_tmp1_));
	gtk_color_button_set_color (self->priv->backgroundColorButton, (_tmp3_ = (preferences_getGdkColor (preferences_get_backgroundColor (preferences), &_tmp2_), _tmp2_), &_tmp3_));
	gtk_color_button_set_color (self->priv->highlightColorButton, (_tmp5_ = (preferences_getGdkColor (preferences_get_highlightColor (preferences), &_tmp4_), _tmp4_), &_tmp5_));
	if (preferences_get_recordLaunch (preferences)) {
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->recordLaunch, TRUE);
	} else {
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->recordLaunch, FALSE);
	}
	if (preferences_get_enableTimeout (preferences)) {
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->enableTimeout, TRUE);
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->timeout, TRUE);
	} else {
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->enableTimeout, FALSE);
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->timeout, FALSE);
	}
	if (recording) {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->enableTimeout, FALSE);
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->timeout, FALSE);
	} else {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->enableTimeout, TRUE);
	}
	gtk_spin_button_set_value (self->priv->timeout, (double) preferences_get_timeout (preferences));
	gtk_widget_show_all ((GtkWidget*) self->priv->dialog);
}


void moserial_preferences_dialog_cancel (moserialPreferencesDialog* self, GtkWidget* w) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	moserial_preferences_dialog_hide (self);
}


gboolean moserial_preferences_dialog_hide (moserialPreferencesDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	gtk_widget_hide_all ((GtkWidget*) self->priv->dialog);
	result = TRUE;
	return result;
}


void moserial_preferences_dialog_systemFontToggled (moserialPreferencesDialog* self, GtkCheckButton* button) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	if (gtk_toggle_button_get_active ((GtkToggleButton*) button)) {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->fontButton, FALSE);
	} else {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->fontButton, TRUE);
	}
}


void moserial_preferences_dialog_enableTimeoutToggled (moserialPreferencesDialog* self, GtkCheckButton* button) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	if (gtk_toggle_button_get_active ((GtkToggleButton*) button)) {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->timeout, TRUE);
	} else {
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->timeout, FALSE);
	}
}


GtkBuilder* moserial_preferences_dialog_get_builder (moserialPreferencesDialog* self) {
	GtkBuilder* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_builder;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void moserial_preferences_dialog_set_builder (moserialPreferencesDialog* self, GtkBuilder* value) {
	GtkBuilder* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_builder = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_builder), _tmp0_);
	g_object_notify ((GObject *) self, "builder");
}


static void _moserial_preferences_dialog_systemFontToggled_gtk_toggle_button_toggled (GtkCheckButton* _sender, gpointer self) {
	moserial_preferences_dialog_systemFontToggled (self, _sender);
}


static void _moserial_preferences_dialog_enableTimeoutToggled_gtk_toggle_button_toggled (GtkCheckButton* _sender, gpointer self) {
	moserial_preferences_dialog_enableTimeoutToggled (self, _sender);
}


static void _moserial_preferences_dialog_ok_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	moserial_preferences_dialog_ok (self, _sender);
}


static void _moserial_preferences_dialog_cancel_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	moserial_preferences_dialog_cancel (self, _sender);
}


static gboolean _moserial_preferences_dialog_hide_gtk_widget_delete_event (GtkDialog* _sender, GdkEvent* event, gpointer self) {
	return moserial_preferences_dialog_hide (self);
}


static GObject * moserial_preferences_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	moserialPreferencesDialog * self;
	parent_class = G_OBJECT_CLASS (moserial_preferences_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = MOSERIAL_PREFERENCES_DIALOG (obj);
	{
		GtkDialog* _tmp0_;
		GtkButton* _tmp1_;
		GtkButton* _tmp2_;
		GtkCheckButton* _tmp3_;
		GtkFontButton* _tmp4_;
		GtkColorButton* _tmp5_;
		GtkColorButton* _tmp6_;
		GtkColorButton* _tmp7_;
		GtkCheckButton* _tmp8_;
		GtkCheckButton* _tmp9_;
		GtkSpinButton* _tmp10_;
		self->priv->dialog = (_tmp0_ = _g_object_ref0 (GTK_DIALOG (gtk_builder_get_object (self->priv->_builder, "preferences_dialog"))), _g_object_unref0 (self->priv->dialog), _tmp0_);
		self->priv->okButton = (_tmp1_ = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_ok"))), _g_object_unref0 (self->priv->okButton), _tmp1_);
		self->priv->cancelButton = (_tmp2_ = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_cancel"))), _g_object_unref0 (self->priv->cancelButton), _tmp2_);
		self->priv->systemFont = (_tmp3_ = _g_object_ref0 (GTK_CHECK_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_use_system_font"))), _g_object_unref0 (self->priv->systemFont), _tmp3_);
		self->priv->fontButton = (_tmp4_ = _g_object_ref0 (GTK_FONT_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_font_button"))), _g_object_unref0 (self->priv->fontButton), _tmp4_);
		self->priv->fontColorButton = (_tmp5_ = _g_object_ref0 (GTK_COLOR_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_font_color_button"))), _g_object_unref0 (self->priv->fontColorButton), _tmp5_);
		self->priv->backgroundColorButton = (_tmp6_ = _g_object_ref0 (GTK_COLOR_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_background_color_button"))), _g_object_unref0 (self->priv->backgroundColorButton), _tmp6_);
		self->priv->highlightColorButton = (_tmp7_ = _g_object_ref0 (GTK_COLOR_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_highlight_color_button"))), _g_object_unref0 (self->priv->highlightColorButton), _tmp7_);
		self->priv->recordLaunch = (_tmp8_ = _g_object_ref0 (GTK_CHECK_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_record_launch"))), _g_object_unref0 (self->priv->recordLaunch), _tmp8_);
		self->priv->enableTimeout = (_tmp9_ = _g_object_ref0 (GTK_CHECK_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_record_enable_timeout"))), _g_object_unref0 (self->priv->enableTimeout), _tmp9_);
		self->priv->timeout = (_tmp10_ = _g_object_ref0 (GTK_SPIN_BUTTON (gtk_builder_get_object (self->priv->_builder, "preferences_record_timeout"))), _g_object_unref0 (self->priv->timeout), _tmp10_);
		g_signal_connect_object ((GtkToggleButton*) self->priv->systemFont, "toggled", (GCallback) _moserial_preferences_dialog_systemFontToggled_gtk_toggle_button_toggled, self, 0);
		g_signal_connect_object ((GtkToggleButton*) self->priv->enableTimeout, "toggled", (GCallback) _moserial_preferences_dialog_enableTimeoutToggled_gtk_toggle_button_toggled, self, 0);
		g_signal_connect_object (self->priv->okButton, "clicked", (GCallback) _moserial_preferences_dialog_ok_gtk_button_clicked, self, 0);
		g_signal_connect_object (self->priv->cancelButton, "clicked", (GCallback) _moserial_preferences_dialog_cancel_gtk_button_clicked, self, 0);
		g_signal_connect_object ((GtkWidget*) self->priv->dialog, "delete-event", (GCallback) _moserial_preferences_dialog_hide_gtk_widget_delete_event, self, 0);
	}
	return obj;
}


static void moserial_preferences_dialog_class_init (moserialPreferencesDialogClass * klass) {
	moserial_preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (moserialPreferencesDialogPrivate));
	G_OBJECT_CLASS (klass)->get_property = moserial_preferences_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = moserial_preferences_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = moserial_preferences_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = moserial_preferences_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOSERIAL_PREFERENCES_DIALOG_BUILDER, g_param_spec_object ("builder", "builder", "builder", GTK_TYPE_BUILDER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("update_preferences", MOSERIAL_TYPE_PREFERENCES_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PREFERENCES);
}


static void moserial_preferences_dialog_instance_init (moserialPreferencesDialog * self) {
	self->priv = MOSERIAL_PREFERENCES_DIALOG_GET_PRIVATE (self);
}


static void moserial_preferences_dialog_finalize (GObject* obj) {
	moserialPreferencesDialog * self;
	self = MOSERIAL_PREFERENCES_DIALOG (obj);
	_g_object_unref0 (self->priv->_builder);
	_g_object_unref0 (self->priv->dialog);
	_g_object_unref0 (self->priv->cancelButton);
	_g_object_unref0 (self->priv->okButton);
	_g_object_unref0 (self->priv->systemFont);
	_g_object_unref0 (self->priv->fontButton);
	_g_object_unref0 (self->priv->fontColorButton);
	_g_object_unref0 (self->priv->backgroundColorButton);
	_g_object_unref0 (self->priv->highlightColorButton);
	_g_object_unref0 (self->priv->recordLaunch);
	_g_object_unref0 (self->priv->enableTimeout);
	_g_object_unref0 (self->priv->timeout);
	G_OBJECT_CLASS (moserial_preferences_dialog_parent_class)->finalize (obj);
}


GType moserial_preferences_dialog_get_type (void) {
	static GType moserial_preferences_dialog_type_id = 0;
	if (moserial_preferences_dialog_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (moserialPreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) moserial_preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (moserialPreferencesDialog), 0, (GInstanceInitFunc) moserial_preferences_dialog_instance_init, NULL };
		moserial_preferences_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "moserialPreferencesDialog", &g_define_type_info, 0);
	}
	return moserial_preferences_dialog_type_id;
}


static void moserial_preferences_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	moserialPreferencesDialog * self;
	self = MOSERIAL_PREFERENCES_DIALOG (object);
	switch (property_id) {
		case MOSERIAL_PREFERENCES_DIALOG_BUILDER:
		g_value_set_object (value, moserial_preferences_dialog_get_builder (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void moserial_preferences_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	moserialPreferencesDialog * self;
	self = MOSERIAL_PREFERENCES_DIALOG (object);
	switch (property_id) {
		case MOSERIAL_PREFERENCES_DIALOG_BUILDER:
		moserial_preferences_dialog_set_builder (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




